"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.quote = quote;
var DQUOTE = "\"".charCodeAt(0);
var SQUOTE = "\'".charCodeAt(0);
var BACKSLASH = "\\".charCodeAt(0);

// quote a string so it can be displayed.

function quote(s) {
  if (s == null) return "null";
  return s.toString().replace(/[^\u0020-\u007e]|\"|\'/g, function (c) {
    var n = c.charCodeAt(0);
    switch (n) {
      case DQUOTE:
        return "\\\"";
      case SQUOTE:
        return "\\\'";
      case BACKSLASH:
        return "\\\\";
      default:
        var escape = "000" + n.toString(16);
        return "\\u" + escape.slice(escape.length - 4);
    }
  });
}
//# sourceMappingURL=strings.js.map