"use strict";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _lib = require("../../lib");

var _lib2 = _interopRequireDefault(_lib);

require("should");
require("source-map-support").install();

describe("Parser.onFail", function () {
  it("overrides an inner failure", function () {
    var p = _lib2["default"].alt(/\d+/, "hello").onFail("Expected number or greeting");
    (function () {
      return p.run("a");
    }).should["throw"](/number or greeting/);
  });

  it("combines across an alt", function () {
    var p = _lib2["default"].alt((0, _lib2["default"])(/\d+/).named("number"), "hello");

    (function () {
      return p.run("a");
    }).should["throw"](/number or 'hello'/);
  });

  it("picks up a new name across an alt", function () {
    var p = _lib2["default"].alt((0, _lib2["default"])(/\d+/).named("number"), "hello").named("widget");

    (function () {
      return p.run("a");
    }).should["throw"](/widget/);
  });
});
//# sourceMappingURL=test_onfail.js.map